<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


/**
 * Définition d’une classe.
 */
class Utils
{ 
	 
	private $iVal; // Un identifiant


	/**
	 * Le constructeur.
	 * @param [type] $valeur [description]
	 */
	public function __construct($valeur)
	{ 
		$this->iVal = $valeur; 
	} 


	/**
	 * Vérifie la cohérence de la valeur
	 * @return [type] [description]
	 */
	public function verifValue()
	{ 
 
		// si l'identifiant est négatif : une exception est levée. 
		if ($this->iVal < 0)
		{ 
			throw new Exception("identifiant non autorise", $this->iVal); 
		} 
	} 

} 



// création de 2 objets. 
$objet = new Utils(1); 

// gestion des erreurs
try
{ 
	echo "Objet 1 : "; 
	$objet->verifValue(); // ne va pas lever d’exception 
	echo "OK<br />"; 
}
catch (Exception $oError)
{ 
	echo "ERREUR ".$oError->getCode()." - ".$oError->getMessage()."<br />"; 
} 


$objet = new Utils(-1); 
try
{ 
	echo "Objet -1 : "; 
	$objet->verifValue(); // va créer une exception (identifiant négatif)
	echo "OK<br />"; 
}
catch (Exception $oError)
{ 
	echo "ERREUR ".$oError->getCode()." - ".$oError->getMessage()."<br />"; 
} 


echo "--<br /><br />"; 

// avec un bloc finally. 
$objet = new Utils(10); 
try
{ 
	echo "Objet 10 : "; 
	$objet->verifValue(); // ne va pas lever d’exception 
	echo "OK<br />";
}
catch (Exception $oError)
{ 
	echo "ERREUR ".$oError->getCode()." - ".$oError->getMessage()."<br />"; 
}
finally
{  // exécute le code dans tous les cas (même si il y a une exception)
	echo "FINALLY<br /><br />"; 
} 


$objet = new Utils(-10); 
try
{ 
	echo "Objet -10 : "; 
	$objet->verifValue(); // va lever une exception 
	echo "OK<br />";
}
catch (Exception $oError)
{ 
	echo "ERREUR ".$oError->getCode()." - ".$oError->getMessage()."<br />"; 
}
finally
{ // exécute le code dans tous les cas (même si il y a une exception)
	echo "FINALLY<br /><br />"; 
} 



?>
